LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_signed.ALL;
USE ieee.std_logic_arith.ALL;
--USE work.ImPackM.ALL;
use work.ImPack.all; 

ENTITY FsmE IS
  PORT (Button        : IN  std_logic;
         Clk12, Reset : IN  std_logic;
         Short, Long  : OUT std_logic);
END;

ARCHITECTURE FsmA OF FsmE IS
	Type StateTypeT is (IDLE, Count, Eval);
	signal Next_S, State_S: StateTypeT; 
	--signal Count_En: std_logic := '0';
	signal Counter_S : std_logic_vector(CounterWidth-1 downto 0);

BEGIN
 Zaehler : process (Reset, Clk12, State_s) is
	begin
	if Reset='0' or State_s=IDLE then
--		Counter_s <= "00000000000000000000000000000000";
     	Counter_s <= (others=> '0');
	elsif rising_edge(Clk12) then
		Counter_S <= Counter_s + 1;
	end if;
 end process;
 
 Comb : process (Button, State_S, Counter_S) is
 begin
	case  State_S  is
		when IDLE =>
		  if Button = '0' then
		  Next_S <= Count;
		  else Next_s <= IDLE;
		  end if;
		  short <= '0';
		  long <= '0';
		when Count =>            
		  if Button = '1' then 
		  Next_s <= Eval;
		  else Next_s <= Count;
		  end if;
		  short <= '0';
		  long <= '0';
		when Eval =>
		  Next_S <= IDLE;
		  if Counter_s > LIMIT then
		   Long <= '1';
			Short <= '0';
		  else
			Long <= '0';
			Short <= '1'; 
		  end if;
		when others =>
		  Next_s <= IDLE;
		  short <= '0';
		  long <= '0';
	end case;
 
 end process;
 
 Reg : process (Reset, Clk12, Next_s) is
 begin
	 if Reset = '0' then
		State_s <= IDLE;
	 elsif rising_edge(Clk12) then
		State_s <= Next_s;
	 end if;
 end process;
 

END;

-- pragma synthesis_off 
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_signed.ALL;
USE ieee.std_logic_arith.ALL;
USE work.ImPackM.ALL;

ENTITY FsmTbE IS
END FsmTbE;

ARCHITECTURE FsmTbA OF FsmTbE IS
  SIGNAL ButtonS, Clk12S, ResetS, ShortS, LongS : std_logic := '0';
  COMPONENT FsmE IS
    PORT(Button        : IN  std_logic;
          Clk12, Reset : IN  std_logic;
          Short, Long  : OUT std_logic); 
  END COMPONENT;

  SIGNAL stopS : std_logic := '0';

BEGIN
  
  FsmI : FsmE
    PORT MAP(ButtonS, Clk12S, ResetS, ShortS, LongS);
  
  Clk12 : PROCESS
  BEGIN
    Clk12S <= '0';
    WAIT FOR T12/2;
    Clk12S <= '1';
    WAIT FOR T12/2;
  END PROCESS;

  ResetS <= '0' AFTER 0*T12,
            '1' AFTER 0.5*T12;
  
  ButtonS <= '1' AFTER 0*T12,
             '0' AFTER 1*T12,
             '1' AFTER 2*T12,
             '0' AFTER 3*T12,
             '1' AFTER 5*T12,
             '0' AFTER 6*T12,
             '1' AFTER 9*T12,
             '0' AFTER 10*T12,
             '1' AFTER 14*T12,
             '0' AFTER 15*T12,
             '1' AFTER 20*T12,
             '0' AFTER 21*T12,
             '1' AFTER 27*T12;
  
  stopS <= '0' AFTER 0*T12,
           '1' AFTER 30*T12;
  ASSERT stopS = '0'
    REPORT "stop simulation"
    SEVERITY failure;

END FsmTbA;
-- pragma synthesis_on
